"use strict";

var _path = require("path");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

const cwd = process.cwd();

const pkg = require((0, _path.join)(cwd, 'package.json'));

module.exports = (baseConfig, env, config) => {
  config.module.rules.push({
    test: /\.tsx?$/,
    use: [{
      loader: require.resolve('ts-loader'),
      options: {
        context: cwd,
        configFile: require.resolve('father-build/template/tsconfig.json'),
        transpileOnly: true
      }
    }, require.resolve('react-docgen-typescript-loader')]
  });
  config.resolve.extensions.push('.ts', '.tsx');
  config.resolve.alias = _objectSpread({}, config.resolve.alias, {
    [pkg.name]: cwd
  });
  config.module.rules.push({
    test: /\.less$/,
    use: [{
      loader: 'style-loader'
    }, {
      loader: 'css-loader'
    }, {
      loader: 'less-loader',
      options: {
        javascriptEnabled: true
      }
    }]
  });
  config.resolve.extensions.push('.less'); // Resolve

  config.resolve.modules = [...(config.resolve.modules || []), (0, _path.join)(cwd, 'node_modules'), (0, _path.join)(__dirname, '../../node_modules')]; // Remove core-js

  delete config.resolve.alias['core-js'];
  return config;
};